'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _justDiff = require('just-diff');

var _reactJsonschemaFormUngp = require('react-jsonschema-form-ungp');

var _reactJsonschemaFormUngp2 = _interopRequireDefault(_reactJsonschemaFormUngp);

var _formTransformer = require('./formTransformer');

var _objectUtils = require('./utils/objectUtils');

var _CustomArrayField = require('./widgets/CustomArrayField');

var _CustomArrayField2 = _interopRequireDefault(_CustomArrayField);

var _CustomFieldTemplate = require('./widgets/CustomFieldTemplate');

var _CustomFieldTemplate2 = _interopRequireDefault(_CustomFieldTemplate);

var _TitleWidget = require('./widgets/mui/TitleWidget');

var _TitleWidget2 = _interopRequireDefault(_TitleWidget);

var _TextFieldWidget = require('./widgets/mui/TextFieldWidget');

var _TextFieldWidget2 = _interopRequireDefault(_TextFieldWidget);

var _TextareaWidget = require('./widgets/mui/TextareaWidget');

var _TextareaWidget2 = _interopRequireDefault(_TextareaWidget);

var _RadioGroupWidget = require('./widgets/mui/RadioGroupWidget');

var _RadioGroupWidget2 = _interopRequireDefault(_RadioGroupWidget);

var _CheckboxesGroupWidget = require('./widgets/mui/CheckboxesGroupWidget');

var _CheckboxesGroupWidget2 = _interopRequireDefault(_CheckboxesGroupWidget);

var _MultipleUploadWidget = require('./widgets/mui/MultipleUploadWidget');

var _MultipleUploadWidget2 = _interopRequireDefault(_MultipleUploadWidget);

var _SelectWidget = require('./widgets/mui/SelectWidget');

var _SelectWidget2 = _interopRequireDefault(_SelectWidget);

var _TableEditableWidget = require('./widgets/mui/TableEditableWidget');

var _TableEditableWidget2 = _interopRequireDefault(_TableEditableWidget);

var _ReactDatePicker = require('./widgets/mui/ReactDatePicker');

var _ReactDatePicker2 = _interopRequireDefault(_ReactDatePicker);

var _RichTextField = require('./widgets/RichTextField');

var _RichTextField2 = _interopRequireDefault(_RichTextField);

var _LinkWidget = require('./widgets/mui/LinkWidget');

var _LinkWidget2 = _interopRequireDefault(_LinkWidget);

var _ParagraphWidget = require('./widgets/mui/ParagraphWidget');

var _ParagraphWidget2 = _interopRequireDefault(_ParagraphWidget);

var _MaskWidget = require('./widgets/mui/MaskWidget');

var _MaskWidget2 = _interopRequireDefault(_MaskWidget);

var _validation = require('./validation');

require('whatwg-fetch');

require('moment/locale/pt-br');

require('bootstrap-grid/dist/grid.css');

require('./index.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var FormDinamicoReactRender = function (_PureComponent) {
    _inherits(FormDinamicoReactRender, _PureComponent);

    function FormDinamicoReactRender() {
        var _temp, _this, _ret;

        _classCallCheck(this, FormDinamicoReactRender);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = _possibleConstructorReturn(this, _PureComponent.call.apply(_PureComponent, [this].concat(args))), _this), _this.state = {
            localFormData: _extends({}, (0, _formTransformer.formDefaultValues)(_this.props.form), (0, _formTransformer.formDataValues)(_this.props.formData))
        }, _this.parseFetchedValues = function (integration, json, modifiedFieldFormData) {
            var formData = {};

            integration.returns.forEach(function (item) {
                Boolean(item.value) && (formData[item.value] = json[item.name]);
            });

            var localFormData = _this.state.localFormData || {};

            _this.setState({
                localFormData: _extends({}, localFormData, modifiedFieldFormData, formData)
            });
        }, _this.fetchFormForFieldChange = function (integration, changes, formData) {
            var headers = _this.props.environment.headers;


            var params = _this.findIntegrationParams(integration, changes, formData);
            var queryString = _this.toQueryString(params);
            var serviceURL = integration.operation + '/' + integration.service + queryString;

            fetch(serviceURL, { 'method': 'GET', 'headers': headers || {} }).then(function (res) {
                return res.json();
            }).then(function (json) {
                Object.keys(json).length && _this.parseFetchedValues(integration, json, formData);
            }).catch(function (e) {
                return console.error(e);
            });
        }, _this.findIntegrationParams = function (integration, changes, formData) {
            var _ref;

            var params = [];

            integration.parameters.forEach(function (mappedParam) {
                var value = formData[mappedParam.name];
                var name = mappedParam.value;
                if (value && name) {
                    var param = {};
                    param[name] = value;
                    params.push(param);
                }
            });

            if (params.length) {
                return params;
            }

            return [(_ref = {}, _ref[changes.path[0]] = changes.value, _ref)];
        }, _this.toQueryString = function (params) {

            var qs = '?';

            params.forEach(function (param) {
                Object.keys(param).forEach(function (key, index) {
                    if (index > 0) qs += '&';
                    qs += key + '=' + param[key];
                });
            });

            return qs;
        }, _this.findIntegrationInChanges = function (integration, changes) {
            return changes.find(function (item) {
                return item.path[0] === integration;
            });
        }, _this.modifyFormForChanges = function (changes, formData) {
            var form = _this.props.form;
            var _form$integrations = form.integrations,
                integrations = _form$integrations === undefined ? [] : _form$integrations;


            integrations.forEach(function (item) {
                var modifiedField = _this.findIntegrationInChanges(item.element, changes);

                Boolean(modifiedField) && _this.fetchFormForFieldChange(item, modifiedField, formData);
            });
        }, _this.handleChange = function (event) {
            var formData = event.formData;
            var onChange = _this.props.onChange;


            var capturedChanges = (0, _justDiff.diff)(_this.state.localFormData, formData).filter(function (item) {
                return ['add', 'replace'].includes(item.op) && Boolean(item.value);
            });

            capturedChanges.length && _this.modifyFormForChanges(capturedChanges, formData);

            onChange && onChange((0, _formTransformer.exportFormDataValeus)(formData));
        }, _this.handleSubmit = function (event) {
            var formData = event.formData;
            var onSubmit = _this.props.onSubmit;


            onSubmit && onSubmit((0, _formTransformer.exportFormDataValeus)(formData));
        }, _temp), _possibleConstructorReturn(_this, _ret);
    }

    FormDinamicoReactRender.getDerivedStateFromProps = function getDerivedStateFromProps(nextProps, prevState) {
        var form = nextProps.form,
            formData = nextProps.formData;


        if ((0, _objectUtils.compare)(form, prevState.form) && (0, _objectUtils.compare)(formData, prevState.formData)) {
            return null;
        }

        var localFormData = prevState.localFormData || {};

        return {
            localFormData: _extends({}, localFormData, (0, _formTransformer.formDefaultValues)(form), (0, _formTransformer.formDataValues)(formData))
        };
    };

    FormDinamicoReactRender.prototype.componentDidMount = function componentDidMount() {
        var fields = Object.keys((0, _formTransformer.formToJSONSchema)(this.props.form).properties);
        var emptyFormData = {};
        var localFormData = this.state.localFormData;


        fields.forEach(function (item) {
            return emptyFormData[item] = '';
        });

        !Object.keys(localFormData).length && this.setState({
            localFormData: emptyFormData
        });
    };

    FormDinamicoReactRender.prototype.render = function render() {
        var _props = this.props,
            onChange = _props.onChange,
            onSubmit = _props.onSubmit,
            form = _props.form,
            formData = _props.formData,
            children = _props.children,
            environment = _props.environment,
            customWidgets = _props.customWidgets,
            noValidate = _props.noValidate,
            rest = _objectWithoutProperties(_props, ['onChange', 'onSubmit', 'form', 'formData', 'children', 'environment', 'customWidgets', 'noValidate']);

        var localFormData = this.state.localFormData;


        var formProps = _extends({}, rest, {
            className: 'container-fluid',
            schema: (0, _formTransformer.formToJSONSchema)(form),
            uiSchema: (0, _formTransformer.formToUISchema)(form, environment),
            formData: localFormData,
            FieldTemplate: _CustomFieldTemplate2.default,
            fields: {
                ArrayField: _CustomArrayField2.default
            },
            onChange: this.handleChange,
            onSubmit: this.handleSubmit
        });

        var formWidgets = _extends({
            TextareaWidget: _TextareaWidget2.default,
            TextWidget: _TextFieldWidget2.default,
            dateWidget: _ReactDatePicker2.default,
            titleWidget: _TitleWidget2.default,
            radio: _RadioGroupWidget2.default,
            checkboxes: _CheckboxesGroupWidget2.default,
            'file-multiple': _MultipleUploadWidget2.default,
            select: _SelectWidget2.default,
            richTextWidget: _RichTextField2.default,
            link: _LinkWidget2.default,
            'table-editable': _TableEditableWidget2.default,
            mask: _MaskWidget2.default,
            paragraph: _ParagraphWidget2.default
        }, customWidgets);

        var validate = function validate(formData, errors) {
            var schema = formProps.schema;

            return (0, _validation.defaultValidation)(schema, formData, errors);
            //TODO: futuramente permitir que a aplicação passe uma função para incluir validações customizadas.
        };

        var FormWithLayout = (0, _reactJsonschemaFormUngp.withLayout)(_reactJsonschemaFormUngp2.default);

        return _react2.default.createElement(
            FormWithLayout,
            _extends({}, formProps, {
                widgets: formWidgets,
                noValidate: noValidate,
                noHtml5Validate: true,
                showErrorList: false,
                validate: validate,
                transformErrors: _validation.transformErrors
            }),
            children
        );
    };

    return FormDinamicoReactRender;
}(_react.PureComponent);

FormDinamicoReactRender.propTypes = process.env.NODE_ENV !== "production" ? {
    form: _propTypes2.default.shape({
        elements: _propTypes2.default.array
    }).isRequired,
    formData: _propTypes2.default.any,
    customWidgets: _propTypes2.default.object,
    /* event handlers */
    onChange: _propTypes2.default.func,
    onError: _propTypes2.default.func,
    onSubmit: _propTypes2.default.func,
    environment: _propTypes2.default.shape({
        upload: _propTypes2.default.shape({
            url: _propTypes2.default.string.isRequired,
            config: _propTypes2.default.object.isRequired
        }),
        customProps: _propTypes2.default.object,
        headers: _propTypes2.default.object,
        disableOnLoadIntegration: _propTypes2.default.boolean
    })
} : {};
exports.default = FormDinamicoReactRender;
module.exports = exports['default'];