'use strict';

exports.__esModule = true;
var defaultValidation = exports.defaultValidation = function defaultValidation(schema, formData, errors) {
    validateMask(schema, formData, errors);
    return errors;
};

var transformErrors = exports.transformErrors = function transformErrors(errors) {
    return errors.map(function (error) {
        if (error.name === 'required') {
            error.message = 'campo obrigatório';
        }
        return error;
    });
};

var validateMask = function validateMask(schema, formData, errors) {

    var inputsMask = findFieldsByType(schema, 'mask');

    if (!inputsMask.length) {
        return;
    }

    inputsMask.map(function (field) {
        var key = field.metadata.key;

        var value = formData[key];

        if (value === undefined) {
            return;
        }

        if (value.indexOf('_') > -1) {
            errors[key].addError('valor inválido');
        }
    });
};

var findFieldsByType = function findFieldsByType(schema, typeToFind) {

    var fields = [];

    Object.keys(schema.properties).map(function (property) {
        var field = schema.properties[property];
        if (field.metadata.type === typeToFind) {
            fields.push(field);
        }
    });

    return fields;
};