'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _FormLabel = require('@material-ui/core/FormLabel');

var _FormLabel2 = _interopRequireDefault(_FormLabel);

var _FormGroup = require('@material-ui/core/FormGroup');

var _FormGroup2 = _interopRequireDefault(_FormGroup);

var _FormControl = require('@material-ui/core/FormControl');

var _FormControl2 = _interopRequireDefault(_FormControl);

var _reactQuill = require('react-quill');

var _reactQuill2 = _interopRequireDefault(_reactQuill);

var _stringUtilts = require('../utils/stringUtilts');

var _arrayUtils = require('../utils/arrayUtils');

require('react-quill/dist/quill.snow.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

/*
* Importar fontes customizadas para o componentes
*
* Não funciona se colocar dentro de uma função
* */
var Font = _reactQuill.Quill.import('formats/font');
Font.whitelist = (0, _arrayUtils.sortArray)([].concat(Font.whitelist, ['Arial', 'Arial-Black']), _stringUtilts.compareStrings);
_reactQuill.Quill.register(Font, true);

function RichTextField(props) {
    var label = props.label,
        options = props.options,
        value = props.value,
        disabled = props.disabled,
        readonly = props.readonly,
        autofocus = props.autofocus,
        onBlur = props.onBlur,
        onFocus = props.onFocus,
        schema = props.schema,
        formContext = props.formContext,
        registry = props.registry,
        inputProps = _objectWithoutProperties(props, ['label', 'options', 'value', 'disabled', 'readonly', 'autofocus', 'onBlur', 'onFocus', 'schema', 'formContext', 'registry']);

    var onChange = function onChange(content, delta, source, editor) {
        return props.onChange(content ? content : options.emptyValue);
    };

    var modules = {
        toolbar: [['bold', 'italic', 'underline', 'strike'], // toggled buttons
        ['blockquote', 'code-block'], [{ 'header': 1 }, { 'header': 2 }], // custom button values
        [{ 'list': 'ordered' }, { 'list': 'bullet' }], [{ 'script': 'sub' }, { 'script': 'super' }], // superscript/subscript
        [{ 'indent': '-1' }, { 'indent': '+1' }], // outdent/indent
        [{ 'direction': 'rtl' }], // text direction

        [{ 'size': ['small', false, 'large', 'huge'] }], // custom dropdown
        [{ 'header': [1, 2, 3, 4, 5, 6, false] }], [{ 'color': [] }, { 'background': [] }], // dropdown with defaults from theme
        [{ 'font': Font.whitelist }], [{ 'align': [] }], ['clean']]
    };

    return _react2.default.createElement(
        'section',
        null,
        _react2.default.createElement(
            _FormControl2.default,
            { component: 'fieldset' },
            _react2.default.createElement(
                _FormLabel2.default,
                {
                    component: 'legend',
                    style: { padding: '6px 0 7px' }
                },
                label
            )
        ),
        _react2.default.createElement(
            _FormGroup2.default,
            { style: { flexWrap: 'nowrap' } },
            _react2.default.createElement(_reactQuill2.default, _extends({
                modules: modules,
                readOnly: readonly,
                disabled: schema.disabled,
                autoFocus: autofocus,
                value: value || ''

            }, inputProps, {
                onChange: onChange,
                onBlur: onBlur && function (range) {
                    return onBlur(inputProps.id, range);
                },
                onFocus: onFocus && function (range) {
                    return onFocus(inputProps.id, range);
                }
            }))
        )
    );
}

exports.default = RichTextField;
module.exports = exports['default'];